<?php

namespace modules\enot\classes\payment;

use payment\PaymentAPI;
use System\Exception;
use System\Logger;

class EnotAPI extends PaymentAPI
{
    public function setFormAction(){
        $this->_form_action = 'https://enot.io/_/pay';
    }

    public function getFormValues()
    {
        $fields = $this->getFields();
        $fields['s'] = $this->getSign($fields);

        return $fields;
    }

    public function getFields()
    {
        $fields = [
            'm' => $this->_shop['shop_id'],
            'oa' => $this->getAmountAsString(),
            'o' => $this->getId(),
            'cr' => strtoupper($this->getCurrency()),
            'fail_url' => $this->getStatusUrl(),
            'success_url' => $this->getSuccessUrl()
        ];

        return $fields;
    }

    public function getSign($fields)
    {
        $sign = md5($fields['m'].':'.$fields['oa'].':'.$this->_shop['secret_key'].':'.$fields['o']);

        return $sign; // возвращаем результат
    }

    final protected function _checkSignature(array $result)
    {
        Logger::log('Enot signature argument: '.$this->_shop['shop_id'].':'.$result['amount'].':'.$this->_shop['secret_key'].':'.$result['merchant_id']);
        Logger::log(json_encode($result));

        $sign = md5($this->_shop['shop_id'].':'.$result['amount'].':'.$this->_shop['secret_key2'].':'.$result['merchant_id']);
        if ($sign === $result['sign_2']) {
            return true;
        }

        return false;
    }

    public function getPayment()
    {
        $result = $_REQUEST;

        if (!$result || empty($result)) {
            throw new Exception('Request not exist');
        }

        if ($this->_checkSignature($result)) {
            $this->verified = true;
        } else {
            throw new Exception('Signature does not match the data');
        }

        $this->_id = $result['merchant_id'];
        $this->_amount = $result['amount'];

        return $this;
    }
}