<?php
namespace modules\enot\controllers\front;


use front\ModuleFrontController;
use model\Bill;
use model\Client;
use model\Currency;
use modules\enot\classes\payment\EnotAPI;
use System\Config;
use System\Notifier;

class EnotStatusController extends ModuleFrontController {
    protected $auth = false;
    public function actionStatus()
    {
        $pconfig = new Config('payments');
        $enot =  new EnotAPI([
            'shop_id' => $pconfig->enot->shop_id,
            'secret_key' => $pconfig->enot->secret_key,
            'secret_key2' => $pconfig->enot->secret_key2
        ]);

        $currency = new Currency($pconfig->enot->currency);
        if(!$currency->isLoadedObject()){
            $currency = Currency::getDefault();
        }

        $payment = $enot->getPayment();
        if ($payment->verified) {
            $bill = new Bill($payment->getId());
            if ($bill->isLoadedObject() &&  $currency->getPrice($bill->total) == $payment->getAmount()) {
                $bill->pay();
                $Client = new Client($bill->client_id);

                Notifier::PaidBill($Client, $bill);

                exit('YES');
            }
        }

        exit('ERROR');
    }
}
