<?php
namespace modules\enot;

use modules\enot\classes\payment\EnotAPI;
use model\Bill;
use model\Currency;
use stdClass;
use System\Config;
use System\Module;
use System\Router;
use System\Tools;

class enot extends Module {
    public $name = 'Платежная система enot.io';
    public $author = '<a target="_blank" href="http://hopebilling.com">hopebilling.com</a>';
    public $category = 3; // for payments systems

    public function install()
    {

        $pconfig = new Config('payments');
        $pconfig->enot = new stdClass();
        $pconfig->enot->enable = 0;
        $pconfig->enot->shop_id = "";
        $pconfig->enot->currency = 0;// for defaults
        $pconfig->enot->secret_key = "";
        $pconfig->enot->secret_key2 = "";
        $pconfig->save();

        $this->registerHook('displayPaymentMethods');
    }

    public function uninstall()
    {
        $pconfig = new Config('payments');
        $pconfig->delete('enot');
        $pconfig->save();

        return parent::uninstall();
    }

    public function displayPaymentMethods(&$view)
    {
        $pconfig = new Config('payments');
        $id_bill = Router::getParam(0);

        $Bill = new Bill($id_bill);
        $view = $this->getModuleView('bill/pay.php');
        $dcurrency = new Currency($this->config->currency_default);
        $currency = new Currency($pconfig->enot->currency);
        if(!$currency->isLoadedObject()){
            $currency = $dcurrency;
        }

        // enot
        $enot = new EnotAPI(array(
            'shop_id'       => $pconfig->enot->shop_id,
            'secret_key'    => $pconfig->enot->secret_key
        ));

        $payment          = $enot->createPayment(array(
            'id'          => $Bill->id,
            'amount'      => Currency::convert($Bill->total, $currency->id),
            'description' => 'Оплата услуг компании',
            'currency'    => $currency->iso
        ));

        $view->enot = $payment;
        // enot end

        $view->id_bill = $id_bill;
    }

    public function actionSetting()
    {
        $pconfig = new Config('payments');

        if (Tools::rPOST()) {
            $pconfig->enot->shop_id = Tools::rPOST('shop_id');
            $pconfig->enot->secret_key = Tools::rPOST('secret_key');
            $pconfig->enot->secret_key2 = Tools::rPOST('secret_key2');
            $pconfig->enot->currency = (int)Tools::rPOST('currency');
            $pconfig->save();
        }

        $view  = $this->getModuleView('setting.php', 'admin');
        $view->pconfig= $pconfig;
        $view->currencies = Currency::factory()->getRows();

        return $view;
    }
}
